package com.fr.plugin.third.party.jsdibgd;

import com.fanruan.api.report.chart.BaseChartType;
import com.fanruan.api.report.chart.BaseChartWithData;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.Authorize;

@EnableMetrics
@Authorize(callSignKey = "com.fr.plugin.third.party.jsdibgd")
public class CustomChartType extends BaseChartType {

    /**
     * 该种图表所有的图表对象实例，比如柱形图就有堆积柱形图，百分比堆积柱形图等等
     *
     * @return 所有的图表对象实例
     */
    @Focus(id = "com.fr.plugin.third.party.jsdibgd", text = "plugin-jsd-ibgd", source = Original.PLUGIN)
    public BaseChartWithData[] getChartTypes() {
        return new BaseChartWithData[]{
                new CustomChartConfig()
        };
    }

    /**
     * 图表在web端展现时需要的JS文件
     *
     * @return JS文件数组
     */
    public String[] getRequiredJS() {
        return new String[]{
                "com/fr/plugin/third/party/jsdibgd/web/echarts.min.js",
                "com/fr/plugin/third/party/jsdibgd/web/echarts-gl.min.js",
                "com/fr/plugin/third/party/jsdibgd/web/custom_map.js",
                "com/fr/plugin/third/party/jsdibgd/web/customChartWrapper.js",

        };
    }

    /**
     * 图表在web端展现时需要的CSS文件
     *
     * @return CSS文件数组
     */
    public String[] getRequiredCss() {
        return new String[]{
                "com/fr/plugin/third/party/jsdibgd/web/common.css"
        };
    }

    /**
     * JS对象名，该对象一般是一个函数，执行后会在给定的dom中绘制图表
     *
     * @return JS对象名
     */
    public String getWrapperName() {
        return "customChartJsdibgdWrapper";
    }

}
