package com.fr.plugin.third.party.jsdibgd;

import com.fanruan.api.design.chart.*;
import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.plugin.third.party.jsdibgd.data.DataCellFieldsPane;
import com.fr.plugin.third.party.jsdibgd.data.DataSetFieldsPane;
import com.fr.plugin.third.party.jsdibgd.ui.CustomGanttTypePane;
import com.fr.plugin.third.party.jsdibgd.ui.CustomStylePane;

public class CustomChartUI extends BaseChartTypeUI {
    public String CHART_NAME = "定制轮播点地图";

    @Override
    public DefaultTypePane getPlotTypePane() {
        return new CustomGanttTypePane();
    }

    @Override
    public BaseDataPane getChartDataPane(AttributeChangeListener listener) {
        return new BaseDataPane(listener) {
            @Override
            protected SingleDataPane createSingleDataPane() {
                return new SingleDataPane(new DataSetFieldsPane(),
                        new DataCellFieldsPane()
                );
            }
        };
    }

    @Override
    public BaseOtherPane[] getAttrPaneArray(AttributeChangeListener listener) {
        return new BaseOtherPane[]{
                //new CustomGanttTitlePane(),
                new CustomStylePane(),
                // new CustomGanttShowSettingsPane(),
                //  new VanChartStylePane(listener),
                new DefaultOtherPane()};
    }

    @Override
    public String getIconPath() {
        return "com/fr/plugin/third/party/jsdibgd/images/chart_icon.png";
    }

    @Override
    public String getName() {
        return CHART_NAME;
    }

    @Override
    public String[] getSubName() {
        return new String[]{
                CHART_NAME
        };
    }

    @Override
    public String[] getDemoImagePath() {
        return new String[]{
                "com/fr/plugin/third/party/jsdibgd/images/chart_type_demo.png"
        };
    }
}
