package com.fr.plugin.third.party.jsdibgd.data;

import com.fanruan.api.design.chart.field.BaseCellDataFieldsPane;
import com.fanruan.api.design.ui.component.formula.UIFormulaTextField;

import java.awt.*;

public class DataCellFieldsPane extends BaseCellDataFieldsPane<DataColumnFieldCollection> {
    private UIFormulaTextField areaPane;
    private UIFormulaTextField deptNamePane;
    private UIFormulaTextField outputValuePane;
    private UIFormulaTextField profitPane;
    private UIFormulaTextField cashFlowPane;
    private UIFormulaTextField newContractPane;
    private UIFormulaTextField longitudePane;
    private UIFormulaTextField latitudePane;


    public void initComponents() {
        areaPane = new UIFormulaTextField();
        deptNamePane = new UIFormulaTextField();
        outputValuePane = new UIFormulaTextField();
        profitPane = new UIFormulaTextField();
        cashFlowPane = new UIFormulaTextField();
        newContractPane = new UIFormulaTextField();
        longitudePane = new UIFormulaTextField();
        latitudePane = new UIFormulaTextField();
        super.initComponents();
    }

    @Override
    protected String[] fieldLabels() {
        return DataColumnFieldCollection.FIELD_LABELS;
    }

    @Override
    protected Component[] fieldComponents() {
        return new Component[]{
                this.areaPane,
                this.deptNamePane,
                this.outputValuePane,
                this.profitPane,
                this.cashFlowPane,
                this.newContractPane,
                this.longitudePane,
                this.latitudePane,
        };
    }

    @Override
    protected UIFormulaTextField[] formulaPanes() {
        return new UIFormulaTextField[]{
                this.areaPane,
                this.deptNamePane,
                this.outputValuePane,
                this.profitPane,
                this.cashFlowPane,
                this.newContractPane,
                this.longitudePane,
                this.latitudePane,
        };
    }

    @Override
    public void populateBean(DataColumnFieldCollection dataConf) {
        populateField(areaPane, dataConf.getAreaName());
        populateField(deptNamePane, dataConf.getDeptName());
        populateField(outputValuePane, dataConf.getOutputValue());
        populateField(profitPane, dataConf.getProfit());
        populateField(cashFlowPane, dataConf.getCashFlow());
        populateField(newContractPane, dataConf.getNewContract());
        populateField(longitudePane, dataConf.getLongitude());
        populateField(latitudePane, dataConf.getLatitude());
    }

    @Override
    public DataColumnFieldCollection updateBean() {
        DataColumnFieldCollection dataConf = new DataColumnFieldCollection();
        updateField(areaPane, dataConf.getAreaName());
        updateField(deptNamePane, dataConf.getDeptName());
        updateField(outputValuePane, dataConf.getOutputValue());
        updateField(profitPane, dataConf.getProfit());
        updateField(cashFlowPane, dataConf.getCashFlow());
        updateField(newContractPane, dataConf.getNewContract());
        updateField(longitudePane, dataConf.getLongitude());
        updateField(latitudePane, dataConf.getLatitude());
        return dataConf;
    }
}
