package com.fr.plugin.third.party.jsdibgd.ui;

import com.fr.base.BaseUtils;
import com.fr.design.dialog.BasicDialog;
import com.fr.design.dialog.BasicPane;
import com.fr.design.dialog.DialogActionAdapter;
import com.fr.design.dialog.FineJOptionPane;
import com.fr.design.gui.ibutton.UIButton;
import com.fr.design.i18n.Toolkit;
import com.fr.design.layout.FRGUIPaneFactory;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;


public class ColorSeriesConfPane extends BasicPane {
    private JList colorList;
    private UIButton addButton;
    private UIButton editButton;
    private UIButton removeButton;
    private UIButton moveUpButton;
    private UIButton moveDownButton;
    ActionListener addActionListener = new ActionListener() {
        public void actionPerformed(ActionEvent var1) {
            final ColorSettingPane var2 =  new ColorSettingPane();
            BasicDialog var3 = var2.showSmallWindow(SwingUtilities.getWindowAncestor(ColorSeriesConfPane.this), new DialogActionAdapter() {
                public void doOk() {
                    Color var1 = var2.update();
                    if (var1 != null) {
                        DefaultListModel var2x = (DefaultListModel) ColorSeriesConfPane.this.colorList.getModel();
                        var2x.addElement(var1);
                        ColorSeriesConfPane.this.colorList.setSelectedIndex(var2x.size() - 1);
                    }

                }
            });
            var3.setTitle("增加颜色...");
            var3.setVisible(true);
        }
    };
    ActionListener editActionListener = new ActionListener() {
        public void actionPerformed(ActionEvent var1) {
            ColorSeriesConfPane.this.editPrinterList();
        }
    };
    ActionListener removeActionListener = new ActionListener() {
        public void actionPerformed(ActionEvent var1) {
            int var2 = ColorSeriesConfPane.this.colorList.getSelectedIndex();
            if (var2 != -1) {
                int var3 = FineJOptionPane.showConfirmDialog(ColorSeriesConfPane.this,  "你确实想删除选中的颜色吗?", Toolkit.i18nText("Fine-Design_Basic_Remove"), 2, 3);
                if (var3 == 0) {
                    ((DefaultListModel) ColorSeriesConfPane.this.colorList.getModel()).remove(var2);
                    if (ColorSeriesConfPane.this.colorList.getModel().getSize() > 0) {
                        if (var2 < ColorSeriesConfPane.this.colorList.getModel().getSize()) {
                            ColorSeriesConfPane.this.colorList.setSelectedIndex(var2);
                        } else {
                            ColorSeriesConfPane.this.colorList.setSelectedIndex(ColorSeriesConfPane.this.colorList.getModel().getSize() - 1);
                        }
                    }

                    ColorSeriesConfPane.this.checkButtonEnabled();
                }

            }
        }
    };
    ActionListener moveUpActionListener = new ActionListener() {
        public void actionPerformed(ActionEvent var1) {
            int var2 = ColorSeriesConfPane.this.colorList.getSelectedIndex();
            if (var2 > 0) {
                DefaultListModel var3 = (DefaultListModel) ColorSeriesConfPane.this.colorList.getModel();
                Object var4 = var3.get(var2 - 1);
                var3.set(var2 - 1, var3.get(var2));
                var3.set(var2, var4);
                ColorSeriesConfPane.this.colorList.setSelectedIndex(var2 - 1);
                ColorSeriesConfPane.this.checkButtonEnabled();
            }

        }
    };
    ActionListener moveDownActionListener = new ActionListener() {
        public void actionPerformed(ActionEvent var1) {
            int var2 = ColorSeriesConfPane.this.colorList.getSelectedIndex();
            if (var2 != -1) {
                if (var2 < ColorSeriesConfPane.this.colorList.getModel().getSize() - 1) {
                    DefaultListModel var3 = (DefaultListModel) ColorSeriesConfPane.this.colorList.getModel();
                    Object var4 = var3.get(var2 + 1);
                    var3.set(var2 + 1, var3.get(var2));
                    var3.set(var2, var4);
                    ColorSeriesConfPane.this.colorList.setSelectedIndex(var2 + 1);
                    ColorSeriesConfPane.this.checkButtonEnabled();
                }

            }
        }
    };
    ListSelectionListener printerSelectionListener = new ListSelectionListener() {
        public void valueChanged(ListSelectionEvent var1) {
            ColorSeriesConfPane.this.checkButtonEnabled();
        }
    };
    MouseAdapter mouseClickedListener = new MouseAdapter() {
        public void mouseClicked(MouseEvent var1) {
            int var2 = var1.getClickCount();
            if (var2 >= 2) {
                ColorSeriesConfPane.this.editPrinterList();
            }

        }
    };

    public class ColorRenderer extends JLabel implements ListCellRenderer {
        @Override
        public Component getListCellRendererComponent(JList list,
                                                      Object value,
                                                      int index,
                                                      boolean isSelected,
                                                      boolean cellHasFocus) {
            if ((value != null) && (value instanceof Color)) {
                Color color = (Color) value;
                this.setOpaque(true);  //此句是重点，设置背景颜色必须先将它设置为不透明的，因为默认是透明的。。。
                this.setText("  ");
                this.setBackground(color);
            }
            return this;
        }
    }

    public ColorSeriesConfPane() {
        this.initComponents();
    }

    protected void initComponents() {
        this.setLayout(FRGUIPaneFactory.createBorderLayout());
        this.setBorder(BorderFactory.createEmptyBorder(6, 2, 4, 2));
        JToolBar var1 = new JToolBar();
        this.add(var1, "North");
        Dimension var2 = new Dimension(24, 24);
        this.addButton = new UIButton(BaseUtils.readIcon("/com/fr/base/images/cell/control/add.png"));
        this.addButton.addActionListener(this.addActionListener);
        this.addButton.setToolTipText(Toolkit.i18nText("Fine-Design_Basic_Add"));
        this.addButton.setPreferredSize(var2);
        this.editButton = new UIButton(BaseUtils.readIcon("/com/fr/design/images/control/edit.png"));
        this.editButton.addActionListener(this.editActionListener);
        this.editButton.setToolTipText(Toolkit.i18nText("Fine-Design_Report_Edit"));
        this.editButton.setPreferredSize(var2);
        this.removeButton = new UIButton(BaseUtils.readIcon("/com/fr/base/images/cell/control/remove.png"));
        this.removeButton.addActionListener(this.removeActionListener);
        this.removeButton.setToolTipText(Toolkit.i18nText("Fine-Design_Basic_Remove"));
        this.removeButton.setPreferredSize(var2);
        this.moveUpButton = new UIButton(BaseUtils.readIcon("/com/fr/design/images/control/up.png"));
        this.moveUpButton.addActionListener(this.moveUpActionListener);
        this.moveUpButton.setToolTipText(Toolkit.i18nText("Fine-Design_Basic_Utils_Move_Up"));
        this.moveUpButton.setPreferredSize(var2);
        this.moveDownButton = new UIButton(BaseUtils.readIcon("/com/fr/design/images/control/down.png"));
        this.moveDownButton.addActionListener(this.moveDownActionListener);
        this.moveDownButton.setToolTipText(Toolkit.i18nText("Fine-Design_Basic_Utils_Move_Down"));
        this.moveDownButton.setPreferredSize(var2);
        var1.add(this.addButton);
        var1.add(this.editButton);
        var1.add(this.removeButton);
        var1.add(this.moveUpButton);
        var1.add(this.moveDownButton);
        this.colorList = new JList(new DefaultListModel());
        this.colorList.addListSelectionListener(this.printerSelectionListener);
        this.colorList.addMouseListener(this.mouseClickedListener);
        this.colorList.setCellRenderer(new ColorRenderer());
        this.add(new JScrollPane(this.colorList), "Center");
        this.checkButtonEnabled();
    }

    protected String title4PopupWindow() {
        return "完成颜色设置";
    }

    private void checkButtonEnabled() {
        this.editButton.setEnabled(false);
        this.removeButton.setEnabled(false);
        this.moveUpButton.setEnabled(false);
        this.moveDownButton.setEnabled(false);
        int var1 = this.colorList.getSelectedIndex();
        if (var1 >= 0) {
            this.editButton.setEnabled(true);
            this.removeButton.setEnabled(true);
            if (var1 > 0) {
                this.moveUpButton.setEnabled(true);
            }

            if (var1 < this.colorList.getModel().getSize() - 1) {
                this.moveDownButton.setEnabled(true);
            }
        }

    }

    public void editPrinterList() {
        final int var1 = this.colorList.getSelectedIndex();
        final ColorSettingPane var2 = new ColorSettingPane();
        BasicDialog var3 = var2.showSmallWindow(SwingUtilities.getWindowAncestor(this), new DialogActionAdapter() {
            public void doOk() {
                Color var1x = var2.update();
                if (var1x != null) {
                    DefaultListModel var2x = (DefaultListModel) ColorSeriesConfPane.this.colorList.getModel();
                    var2x.remove(var1);
                    var2x.add(var1, var1x);
                    ColorSeriesConfPane.this.colorList.setSelectedIndex(var1);
                }

            }
        });
        var2.populate((Color) this.colorList.getSelectedValue());
        var3.setTitle( "编辑颜色...");
        var3.setVisible(true);
    }

    public void populate(List<Integer> colors) {
        DefaultListModel var3 = (DefaultListModel) this.colorList.getModel();
        var3.removeAllElements();
        if ((colors == null) || (colors.size() <= 0)) {
            return;
        }
        int size = colors.size();
        for (int i = 0, max = size - 1; i <= max; i++) {
            var3.addElement(new Color(colors.get(i)));
        }
        if (size >= 1) {
            this.colorList.setSelectedIndex(0);
        }
    }

    public List update() {
        List<Integer> var2 = new ArrayList();
        DefaultListModel var3 = (DefaultListModel) this.colorList.getModel();
        Color color;
        for (int i = 0, max = var3.size() - 1; i <= max; i++) {
            color = (Color) var3.get(i);
            var2.add(color.getRGB());
        }
        return var2;
    }


}
