package com.fr.plugin.third.party.jsdibgd.ui;


import com.fr.design.beans.FurtherBasicBeanPane;
import com.fr.design.dialog.BasicPane;
import com.fr.design.gui.ibutton.UITabGroup;

import javax.swing.*;
import java.awt.*;
import java.util.List;


public abstract class CustomMultiTabPane<T> extends FurtherBasicBeanPane<T> {
    private static final long serialVersionUID = 2298609199400393886L;
    protected UITabGroup tabPane;
    protected String[] NameArray;
    protected JPanel centerPane;
    protected CardLayout cardLayout = new CardLayout();
    protected List<BasicPane> paneList;

    protected abstract List<BasicPane> initPaneList();

    public abstract void populateBean(T var1);

    public abstract void updateBean(T var1);

    public int getSelectedIndex() {
        return this.tabPane.getSelectedIndex();
    }

    public CustomMultiTabPane() {
        //this.relayoutWhenListChange();
    }

    public void relayoutWhenListChange() {
        this.centerPane = new JPanel(this.cardLayout) {
            public Dimension getPreferredSize() {
                return  getSelectedIndex() == -1 ? super.getPreferredSize() : paneList.get(getSelectedIndex()).getPreferredSize();
            }
        };
        paneList = this.initPaneList();
        this.NameArray = new String[this.paneList.size()];
        for(int var1 = 0; var1 < this.paneList.size(); ++var1) {
            BasicPane var2 = this.paneList.get(var1);
            this.NameArray[var1] = var2.getTitle();
            this.centerPane.add(var2, this.NameArray[var1]);
        }

        this.tabPane = new UITabGroup(this.NameArray) {
            public void tabChanged(int var1) {
                dealWithTabChanged(var1);
            }
        };
        this.tabPane.setSelectedIndex(0);
        this.tabPane.tabChanged(0);
        this.initLayout();
    }

    protected void dealWithTabChanged(int var1) {
        this.cardLayout.show(this.centerPane, this.NameArray[var1]);
        this.tabChanged();
    }

    protected void tabChanged() {
    }

    protected void initLayout() {
        this.setLayout(new BorderLayout(0, 4));
        this.add(this.tabPane, "North");
        this.add(this.centerPane, "Center");
    }
}
