package com.fr.plugin.third.party.jsdibgd.ui;

import com.fanruan.api.design.ui.component.UILabel;
import com.fanruan.api.design.ui.layout.TableLayoutKit;
import com.fr.design.dialog.BasicPane;
import com.fr.design.style.color.ColorSelectBox;
import com.fr.plugin.third.party.jsdibgd.CustomChartConfig;
import com.fr.plugin.third.party.jsdibgd.ui.spinner.CustomUIBoundSpinner;

import javax.swing.*;
import java.awt.*;


/**
 * 柱形宽度配置
 */
public class CylinderWidthConfPane extends BasicPane {
    private ColorSelectBox selectedAreaColorColorSelectBox;
    private ColorSelectBox positionDynamicColorColorSelectBox;
    private CustomUIBoundSpinner mapSymbolSizeBoundSpinner;
    private CustomUIBoundSpinner selectSymbolSizeBoundSpinner;

    public CylinderWidthConfPane() {
        this.initComponents();
    }

    protected void initComponents() {
        this.setLayout(new BorderLayout());
        JPanel panel0 = new JPanel();
        panel0.setLayout(new FlowLayout(0, 0, 0));

        selectedAreaColorColorSelectBox = new ColorSelectBox(100);
        positionDynamicColorColorSelectBox = new ColorSelectBox(100);
        mapSymbolSizeBoundSpinner = new CustomUIBoundSpinner(1, 10000, 1, 10);

        selectSymbolSizeBoundSpinner = new CustomUIBoundSpinner(1, 10000, 1, 10);

        Component[][] components = new Component[][]{
                //{new UILabel("选中区域颜色:"), selectedAreaColorColorSelectBox},
                //{new UILabel("位置动态颜色:"), positionDynamicColorColorSelectBox},
                {new UILabel("图标大小:"), mapSymbolSizeBoundSpinner},
                {new UILabel("选中图标大小:"), selectSymbolSizeBoundSpinner},
        };
        double p = TableLayoutKit.PREFERRED;
        double[] rowSize = new double[]{p, p, p, p};
        double[] columnSize = new double[]{p, 100};
        JPanel settingsUI = TableLayoutKit.createTableLayoutPane(components, rowSize, columnSize);
        this.add(settingsUI, BorderLayout.CENTER);
    }

    protected String title4PopupWindow() {
        return "地图设置";
    }

    public void populate(CustomChartConfig conf) {
        selectedAreaColorColorSelectBox.setSelectObject(new Color(conf.getSelectedAreaColor()));
        positionDynamicColorColorSelectBox.setSelectObject(new Color(conf.getPositionDynamicColor()));
        mapSymbolSizeBoundSpinner.setValue(conf.getMapSymbolSize());

        selectSymbolSizeBoundSpinner.setValue(conf.getSelectSymbolSize());
    }

    public void update(CustomChartConfig conf) {
        conf.setSelectedAreaColor(selectedAreaColorColorSelectBox.getSelectObject().getRGB());
        conf.setPositionDynamicColor(positionDynamicColorColorSelectBox.getSelectObject().getRGB());
        conf.setMapSymbolSize(getIntegerValue(mapSymbolSizeBoundSpinner.getValue()));

        conf.setSelectSymbolSize(getIntegerValue(selectSymbolSizeBoundSpinner.getValue()));
    }

    private int getIntegerValue(double value) {
        int tempValue = (int) value;
        if (tempValue <= 0) {
            tempValue = 0;
        }
        return tempValue;
    }

}
