package com.fr.plugin.third.party.jsdibgd.ui;

import com.fanruan.api.design.ui.component.UICheckBox;
import com.fanruan.api.design.ui.component.UILabel;
import com.fanruan.api.design.ui.component.UITextField;
import com.fanruan.api.design.ui.layout.TableLayoutKit;
import com.fr.design.dialog.BasicPane;
import com.fr.plugin.third.party.jsdibgd.CustomChartConfig;

import javax.swing.*;
import java.awt.*;


/**
 * 柱形宽度配置
 */
public class LinkageConfPane extends BasicPane {
    private UICheckBox linkedCheckBox;
    private UITextField widgetNamesTextField;
    private UITextField paraNameTextField;

    public LinkageConfPane() {
        this.initComponents();
    }

    protected void initComponents() {
        this.setLayout(new BorderLayout());
        JPanel panel0 = new JPanel();
        panel0.setLayout(new FlowLayout(0, 0, 0));

        linkedCheckBox = new UICheckBox();
        widgetNamesTextField = new UITextField();
        paraNameTextField = new UITextField();
        paraNameTextField.setEditable(false);

        UILabel label = new UILabel("联动组件名称:");
        label.setToolTipText("多个名称用逗号隔开");
        Component[][] components = new Component[][]{
                {new UILabel("启用:"), linkedCheckBox},
                {label, widgetNamesTextField},
                {new UILabel("联动参数名称:"), paraNameTextField},
        };
        double p = TableLayoutKit.PREFERRED;
        double[] rowSize = new double[]{p, p, p};
        double[] columnSize = new double[]{p, 100};
        JPanel settingsUI = TableLayoutKit.createTableLayoutPane(components, rowSize, columnSize);
        this.add(settingsUI, BorderLayout.CENTER);
    }

    protected String title4PopupWindow() {
        return "图表联动";
    }

    public void populate(CustomChartConfig conf) {
        linkedCheckBox.setSelected(conf.isLinkEnable());
        widgetNamesTextField.setText(conf.getWidgetNames());
        paraNameTextField.setText(conf.getParaName());
    }

    public void update(CustomChartConfig conf) {
        conf.setLinkEnable(linkedCheckBox.isSelected());
        conf.setWidgetNames(widgetNamesTextField.getText());
        conf.setParaName(paraNameTextField.getText());
    }

    private int getIntegerValue(double value) {
        int tempValue = (int) value;
        if (tempValue <= 0) {
            tempValue = 0;
        }
        return tempValue;
    }

}
