package com.fr.plugin.third.party.jsdibgd.ui.spinner;

import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

/**
 * 定制此组件,是为了修复若组件值和设置值相同时,不显示设置值问题
 */
public class CustomUIBoundSpinner extends CustomUISpinner {
    public CustomUIBoundSpinner(double minValue, double maxValue, double dierta) {
        super(minValue, maxValue, dierta);
    }

    public CustomUIBoundSpinner(double minValue, double maxValue, double dierta, double defaultValue) {
        super(minValue, maxValue, dierta, defaultValue);
    }

    @Override
    protected void initTextFiledListeners() {
        this.getTextField().addFocusListener(new FocusAdapter() {
            @Override
            public void focusLost(FocusEvent e) {
                setTextFieldValue(getTextField().getValue());
                setTextField(value);
            }
        });

        this.getTextField().addKeyListener(new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    setTextFieldValue(getTextField().getValue());
                    setTextField(value);
                }
            }
        });
    }

    @Override
    protected void setTextField(double value) {
        this.getTextField().setValue(value);
    }
}
