!(function () {
    window.JsdibgdMap = window.JsdibgdMap || {};

    JsdibgdMap.currentIndex = 0;
    JsdibgdMap.lastClickTimestamp = 0;

    JsdibgdMap.earthChart = {};
    JsdibgdMap.option = {};
    JsdibgdMap.tooltipId = "JsdibgdTooltip";
    JsdibgdMap.jqueryTooltipId = "#JsdibgdTooltip";
    JsdibgdMap.jqueryTooltipIdDeptName = "#JsdibgdTooltip-deptName";

    Van.FRChartBridge.customChartJsdibgdWrapper = Van.FRChartBridge.AbstractChart.extend({
        _init: function (dom, option) {
            //debugger;
            //var mapChart = echarts.init(dom, null, {renderer: 'svg'});
            $(JsdibgdMap.jqueryTooltipId).remove();
            var labelBgPath = FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/label_bg.png';
            var trianglePath = FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/triangle.png';
            var tooltipContent = '<div id="JsdibgdTooltip" style="background-image:url(' + labelBgPath + ');" >' +
                '<div id="JsdibgdTooltip-deptName"></div>' +
                '<div class="JsdibgdTooltip-value"  style="margin-top: 4px;"><div class="JsdibgdTooltip-value-img" style="background-image:url(' + trianglePath + ');"></div><div class="JsdibgdTooltip-value-title">新签合同</div>&nbsp;:&nbsp;<span  id="JsdibgdTooltip-newContract"></span></div>' +
                '<div class="JsdibgdTooltip-value"  ><div class="JsdibgdTooltip-value-img" style="background-image:url(' + trianglePath + ');"></div><div class="JsdibgdTooltip-value-title">产值</div>&nbsp;:&nbsp;<span  id="JsdibgdTooltip-outputValue"></span></div>' +
                '<div class="JsdibgdTooltip-value"  ><div class="JsdibgdTooltip-value-img" style="background-image:url(' + trianglePath + ');"></div><div class="JsdibgdTooltip-value-title">利润</div>&nbsp;:&nbsp;<span  id="JsdibgdTooltip-profit"></span></div>' +
                '<div class="JsdibgdTooltip-value"  ><div class="JsdibgdTooltip-value-img" style="background-image:url(' + trianglePath + ');"></div><div class="JsdibgdTooltip-value-title">现金流</div>&nbsp;:&nbsp;<span  id="JsdibgdTooltip-cashFlow"></span></div>' +

                '</div>';
            $('body').append(tooltipContent);

            var mapChart = echarts.init(dom);
            JsdibgdMap.earthChart = mapChart;
            JsdibgdMap.option = option;
            this._setConfigJsdibgd(mapChart, option, false);
            mapChart.on('click', this.getLinkFun());
            var tempThis = this;
            mapChart.on('mouseover', function (params) {
                if (tempThis._isNotPoint(params)) {
                    return;
                }
                var index = params.data.dataIndex - 1;
                JsdibgdMap.currentIndex = index;
                JsdibgdMap.lastClickTimestamp = new Date().getTime();
                tempThis._setConfigJsdibgd(JsdibgdMap.earthChart, JsdibgdMap.option, true);
            });
            return mapChart;
        },

        _refresh: function (chart, option) {
            var flag = this._isRefreshJsdibgd();
            if (!flag) {
                return;
            }
            this._setConfigJsdibgd(chart, option, true);
        },

        _resize: function (chart) {
            chart.resize();
        },
        _emptyData: function (options) {
            return options.series.data.length === 0;
        },
        _linkJsdibgd: function () {
            //debugger;
            this.getLinkFun();
        },
        _isPoint: function (params) {
            if (params && params.componentType && (params.componentType == 'series')) {
                return true;
            }
            return false;
        },
        _isNotPoint: function (params) {
            return !this._isPoint(params);
        },
        _doLink: function (params) {
            if (this._isNotPoint(params)) {
                return;
            }
            var hyperLink = params.hyperLink || this.options.chartAttr.hyperLink;
            this._doLinkWithFilter(params, hyperLink);
        },
        _isRefreshJsdibgd: function () {
            var currentTimestamp = new Date().getTime();
            var lastTimestamp = JsdibgdMap.lastClickTimestamp + 10 * 1000;

            if (lastTimestamp >= currentTimestamp) {
                return false;
            }
            return true;
        },
        _setConfigJsdibgd: function (earthChart, option, refreshOption) {
            if (!(option.dataStatus === true)) {
                return;
            }
            var mapConfig = option.mapConfig;
            var stationNameFontConfig = option.stationNameFontConfig;
            var configDatas = option.configDatas;
            if ((configDatas == undefined) || (configDatas.length <= 0)) {
                return;
            }

            var cIndex = JsdibgdMap.currentIndex;
            if (refreshOption && (refreshOption == true)) {
                cIndex = JsdibgdMap.currentIndex + 1
            }
            if (cIndex >= configDatas.length) {
                cIndex = 0;
            }
            JsdibgdMap.currentIndex = cIndex;

            var currentData = configDatas[JsdibgdMap.currentIndex];
            var dataContent = new Array();
            var effectContent = new Array();
            var configData;
            var tempData;
            var currentPlace;
            var currentConfigData;
            for (var i = 0, max = configDatas.length - 1; i <= max; i++) {

                configData = configDatas[i];
                tempData = {
                    value: configData.place,
                    areaName: configData.areaName,
                    deptName: configData.deptName,
                    outputValue: configData.outputValue,
                    profit: configData.profit,
                    cashFlow: configData.cashFlow,
                    newContract: configData.newContract,
                    dataIndex: configData.dataIndex
                }
                if (i == JsdibgdMap.currentIndex) {
                    effectContent.push(tempData);
                    currentPlace = configData.place;
                    currentConfigData = configData;
                    //continue;
                }
                dataContent.push(tempData);
            }


            var labelBgPath = FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/label_bg.png';
            var trianglePath = FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/triangle.png';
            var beamPath = FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/beam.png';
            var pointPath = 'image://' + FR.fineServletURL + '/resources?path=com/fr/plugin/third/party/jsdibgd/images/point.png';
            var geoOption = {
                //backgroundColor: 'rgba(0,23,30,1)',
                backgroundColor: 'transparent',
                geo: {
                    map: 'custom_map',
                    left: 0,
                    top: 5,
                    right: 0,
                    bottom: 0,
                    //boundingCoords: [[-180, 90], [180, -90]],
                    zoom: 0.95, //当前视角的缩放比例
                    aspectScale: 0.86,
                    roam: false,
                    itemStyle: {
                        areaColor: '#062355',
                        borderColor: '#357cf8',
                    },
                    tooltip: {
                        show: false
                    },
                    emphasis: {
                        label: {
                            show: false
                        },
                        itemStyle: {
                            areaColor: {
                                type: 'radial',
                                x: 0.5,
                                y: 0.5,
                                r: 0.5,
                                colorStops: [{
                                    offset: 0, color: '#062355' // 0% 处的颜色
                                }, {
                                    offset: 0.7, color: '#062355' // 0% 处的颜色
                                }, {
                                    offset: 0.8, color: 'rgba(21, 233, 77,  0)' // 100% 处的颜色
                                }, {
                                    offset: 1, color: 'rgba(21, 233, 77,  0.05)' // 100% 处的颜色
                                }],
                                global: true // 缺省为 false
                            },
                            borderColor: '#15e94d',
                            borderWidth: 2,
                            shadowColor: 'rgba(21, 233, 77,  0.05)',
                            shadowBlur: 10
                        }
                    },
                    select: {
                        label: {
                            show: false
                        }
                    },
                    label: {
                        show: false,
                        textStyle: {
                            fontSize: 22,
                            fontWeight: 'lighter',
                            color: '#ff0000'
                        }
                    },
                    regions: [{
                        name: currentData.areaName1,
                        selected: true,
                        select: {
                            itemStyle: {
                                areaColor: {
                                    type: 'radial',
                                    x: 0.5,
                                    y: 0.5,
                                    r: 0.5,
                                    colorStops: [{
                                        offset: 0, color: '#062355' // 0% 处的颜色
                                    }, {
                                        offset: 0.7, color: '#062355' // 0% 处的颜色
                                    }, {
                                        offset: 0.8, color: 'rgba(21, 233, 77,  0)' // 100% 处的颜色
                                    }, {
                                        offset: 1, color: 'rgba(21, 233, 77,  0.05)' // 100% 处的颜色
                                    }],
                                    global: true // 缺省为 false
                                },
                                borderColor: '#15e94d',
                                borderWidth: 2,
                                shadowColor: 'rgba(21, 233, 77,  0.05)',
                                shadowBlur: 10
                            }
                        }
                    }]
                },
                tooltip: {
                    show: false,
                    alwaysShowContent: true
                },
                series: [
                    {
                        type: 'scatter',
                        coordinateSystem: 'geo',
                        zlevel: 3,
                        //color: mapConfig.positionDynamicColor,
                        silent: false,
                        name: "数据",
                        rippleEffect: {
                            brushType: 'stroke'
                        },
                        symbolSize: mapConfig.mapSymbolSize,
                        symbol: pointPath,
                        label: {
                            show: false, //-------------------------
                            position: 'right',
                            formatter: '{b}',
                            textStyle: {
                                fontWeight: 'lighter',
                                fontSize: stationNameFontConfig.size,
                                color: stationNameFontConfig.color
                            }
                        },
                        tooltip: {
                            show: false,
                            alwaysShowContent: true,
                            formatter: function (params) {
                                console.log(params);
                                return "test";
                            }
                        },
                        emphasis: {
                            itemStyle: {
                                color: '#ff6815',
                            }
                        },
                        data: dataContent
                    }, {
                        name: "光束",
                        type: 'scatter',
                        coordinateSystem: 'geo',
                        zlevel: 4,
                        //color: mapConfig.positionDynamicColor,
                        silent: false,
                        rippleEffect: {
                            brushType: 'stroke'
                        },
                        symbolSize: 0,
                        symbol: pointPath,
                        label: {
                            show: true,
                            position: 'top',
                            distance: 5,
                            width: 4,
                            height: 30,
                            formatter: '',
                            backgroundColor: {
                                image: beamPath
                            },
                        },
                        emphasis: {
                            scale: true,

                        },
                        data: effectContent
                    }, {
                        name: "提示信息",
                        type: 'effectScatter',
                        coordinateSystem: 'geo',
                        zlevel: 5,
                        //color: mapConfig.positionDynamicColor,
                        silent: false,
                        rippleEffect: {
                            brushType: 'stroke'
                        },
                        symbolSize: mapConfig.selectSymbolSize,
                        symbol: pointPath,
                        label: {
                            show: false,
                            position: 'top',
                            distance: 25,
                            width: 160,
                            height: 110,
                            formatter: function (params) {
                                //debugger;
                                return '{hr|}\n{a|' + params.data.deptName + '}\n{hr1|}\n　{c|　} {b| 产　　值 : ' + params.data.outputValue + '}\n{hr2|}\n　{c|　} {b| 利　　润 : ' + params.data.profit + '}\n{hr2|}\n　{c|　} {b| 现  金 流 : ' + params.data.cashFlow + '}\n{hr2|}\n　{c|　} {b| 新签合同 : ' + params.data.newContract + '}';
                            },
                            //backgroundColor: '#c6faff',
                            backgroundColor: {
                                image: labelBgPath
                            },
                            //borderColor: '#00fdfc',
                            borderWidth: 0,
                            borderRadius: 4,
                            rich: {
                                a: {
                                    color: '#000000',
                                    //lineHeight: 40,
                                    align: 'center',
                                    // backgroundColor: '#2b9fff',
                                },
                                hr: {
                                    borderColor: 'transparent',
                                    width: '100%',
                                    borderWidth: 2,
                                    height: 20
                                },
                                hr1: {
                                    borderColor: 'transparent',
                                    width: '100%',
                                    borderWidth: 2,
                                    height: 11
                                },
                                hr2: {
                                    borderColor: 'transparent',
                                    width: '100%',
                                    borderWidth: 2,
                                    height: 5
                                },
                                b: {
                                    color: '#ffffff',
                                    //fontSize: 14,
                                    //fontWeight: 'bold',
                                    //lineHeight: 20,
                                    align: 'left'
                                },
                                c: {
                                    color: 'transparent',
                                    //fontSize: 14,
                                    //fontWeight: 'bold',
                                    //lineHeight: 20,
                                    align: 'left',
                                    backgroundColor: {
                                        image: trianglePath
                                    },
                                },
                                per: {
                                    color: '#fff',
                                    backgroundColor: '#4C5058',
                                    padding: [3, 4],
                                    borderRadius: 4
                                }
                            }
                        },
                        emphasis: {
                            scale: true,
                        },
                        data: effectContent
                    }
                ]
            };
            if (refreshOption && (refreshOption == true)) {
                earthChart.setOption(geoOption, true);
            } else {
                earthChart.setOption(geoOption);
            }
            JsdibgdMap.earthChart = earthChart;
            JsdibgdMap.option = option;
            var tempPlace = earthChart.convertToPixel('geo', currentPlace);
            //console.log(tempPlace);
            var leftValue = $(earthChart._dom).offset().left + (tempPlace[0].toFixed(2) - 80 + 0);
            var topValue = $(earthChart._dom).offset().top + (tempPlace[1].toFixed(2) - 145 + 0);
            if (leftValue < 0) {
                leftValue = 0;
            }
            if (topValue < 0) {
                topValue = 0;
            }
            leftValue = leftValue + "px";
            topValue = topValue + "px";
            $(JsdibgdMap.jqueryTooltipId).css("left", leftValue);
            $(JsdibgdMap.jqueryTooltipId).css("top", topValue);

            $(JsdibgdMap.jqueryTooltipIdDeptName).text(currentConfigData.deptName);

            $('#JsdibgdTooltip-outputValue').text(currentConfigData.outputValue);
            $('#JsdibgdTooltip-profit').text(currentConfigData.profit);
            $('#JsdibgdTooltip-cashFlow').text(currentConfigData.cashFlow);
            $('#JsdibgdTooltip-newContract').text(currentConfigData.newContract);
        }

    })
})();